from hashlib import shake_256
from datetime import date, timedelta


CONFIG_DAYS = 126
CONFIG_VERS = '001'
CONFIG_SHAK = 1024
CONFIG_DATE = '%m%Y%d'


class Crypme:

    def atob(self, a):
        nI = 0
        nF = ''
        for n in a:
            nG = self.grid[nI]
            nF += nG[int(n)]
            nI += 1

        return nF

    def btoa(self, b):

        a = ''
        i = 0
        x = 4
        r = [b[y - x:y] for y in range(x, len(b) + x, x)]


        for h in r:
            a += str(self.grid[i].index(h))
            i += 1

        return a

    def getGrid(self, dateChoice: date = None):

        if not dateChoice: dateChoice = date.today()

        hash_str = 'CRYPM3' + CONFIG_VERS + (
                    dateChoice + timedelta(days=CONFIG_DAYS)
        ).strftime(CONFIG_DATE)

        hash_shk = shake_256(hash_str.encode()).hexdigest(CONFIG_SHAK)

        hash_idx = 0
        hash_idy = 0
        hash_idz = 0
        hash_arr = []

        while hash_idx < 160 * 4:  # (len(hash_shk) or 160):
            fact = hash_idx
            part = hash_shk[fact:fact + 4]

            if hash_idz not in hash_arr: hash_arr.append([])

            hash_arr[hash_idz].append(part)

            hash_idx += 4
            hash_idy += 1
            hash_idz += 1

            if len(hash_arr[hash_idz - 1]) == 11:
                break

            if hash_idy == 10:
                hash_idy = 0

            if hash_idz == 16:
                hash_idz = 0

        self.grid = hash_arr
        return self.grid